"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AudioWorkerNode = require("audio-worker-node");
var AudioWorkerGlobalScope = require("./AudioWorkerGlobalScope");
var AudioWorkerNodeProcessor = require("./AudioWorkerNodeProcessor");
var AudioWorkerParamDescriptor = require("./AudioWorkerParamDescriptor");
var findIndex = require("lodash.findindex");

var AudioWorker = (function () {
  _createClass(AudioWorker, null, [{
    key: "create",
    value: function create(audioContext, workerThread) {
      return new Promise(function (resolve) {
        var scope = new AudioWorkerGlobalScope(audioContext.sampleRate);
        var worker = new AudioWorker(audioContext, scope);

        setTimeout(function () {
          workerThread.call(scope, scope);

          resolve(worker);

          setTimeout(function () {
            if (typeof worker._onloaded === "function") {
              worker._onloaded({ type: "loaded" });
            }
          }, 0);
        }, 0);
      });
    }
  }]);

  function AudioWorker(audioContext, scope) {
    _classCallCheck(this, AudioWorker);

    this.__target__ = scope;
    scope.__target__ = this;

    this._context = audioContext;
    this._onmessage = null;
    this._onloaded = null;
    this._parameters = [];
  }

  _createClass(AudioWorker, [{
    key: "postMessage",
    value: function postMessage(message) {
      var _this = this;

      setTimeout(function () {
        if (_this.__target__ && typeof _this.__target__.onmessage === "function") {
          _this.__target__.onmessage({ data: message });
        }
      }, 0);
    }
  }, {
    key: "terminate",
    value: function terminate() {}
  }, {
    key: "createNode",
    value: function createNode(numberOfInputs, numberOfOutputs) {
      var _this2 = this;

      var proc = new AudioWorkerNodeProcessor();
      var node = new AudioWorkerNode(this._context, this.__target__.onaudioprocess, {
        numberOfInputs: numberOfInputs,
        numberOfOutputs: numberOfOutputs,
        parameters: this._parameters,
        processor: proc
      });

      setTimeout(function () {
        if (_this2.__target__ && typeof _this2.__target__.onnodecreate === "function") {
          node.__target__ = proc;
          proc.__target__ = node;

          _this2.__target__.onnodecreate({
            type: "nodecreate",
            node: proc,
            inputs: new Array(numberOfInputs),
            outputs: new Array(numberOfOutputs)
          });
        }
      }, 0);

      return node;
    }
  }, {
    key: "addParameter",
    value: function addParameter(name, defaultValue) {
      var index = findIndex(this._parameters, function (param) {
        return param.name === name;
      });

      if (index === -1) {
        index = this._parameters.length;
        this._parameters[index] = new AudioWorkerParamDescriptor(name, defaultValue);
      }

      return this._parameters[index];
    }
  }, {
    key: "removeParameter",
    value: function removeParameter(name) {
      var index = findIndex(this._parameters, function (param) {
        return param.name === name;
      });

      if (index !== -1) {
        this._parameters.splice(index, 1);
      }
    }
  }, {
    key: "onmessage",
    get: function get() {
      return this._onmessage;
    },
    set: function set(callback) {
      if (callback === null || typeof callback === "function") {
        this._onmessage = callback;
      }
    }
  }, {
    key: "onloaded",
    get: function get() {
      return this._onloaded;
    },
    set: function set(callback) {
      if (callback === null || typeof callback === "function") {
        this._onloaded = callback;
      }
    }
  }, {
    key: "parameters",
    get: function get() {
      return this._parameters.slice();
    }
  }]);

  return AudioWorker;
})();

module.exports = AudioWorker;