"use strict";

var AudioWorker = require("./AudioWorker");
var loadScript = require("./utils/loadScript");
var AudioContext = global.AudioContext || global.webkitAudioContext;

module.exports = function (compiler) {
  var compile = compiler.compile || null;

  function create(audioContext, scriptURL) {
    return loadScript(scriptURL).then(function (code) {
      if (compile) {
        code = compile(code);
      }
      return AudioWorker.create(audioContext, eval.call(null, "\n        (function(self) { \"use strict\"; " + code + " })\n      "));
    });
  }

  function polyfill() {
    if (AudioContext && !AudioContext.prototype.createAudioWorker) {
      AudioContext.prototype.createAudioWorker = function (scriptURL) {
        return create(this, scriptURL);
      };
    }
  }

  return { create: create, polyfill: polyfill };
};