"use strict";

function loadScript(scriptURL) {
  return new Promise(function (resolve, reject) {
    var xhr = new global.XMLHttpRequest();

    xhr.open("GET", scriptURL);

    xhr.onload = function () {
      /* istanbul ignore else */
      if (xhr.readyState === 4) {
        if (xhr.status === 200) {
          resolve(xhr.response);
        } else {
          reject(new Error(xhr.statusText));
        }
      }
    };
    xhr.onerror = function () {
      reject(new Error(xhr.statusText));
    };

    xhr.send();
  });
}

module.exports = loadScript;